// Coselica Toolbox for Scicoslab
// Copyright (C) 2009-2012  Dirk Reusch, Kybernetik Dr. Reusch
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.

function [x,y,typ]=CEMI_IdealClosingSwitch(job,arg1,arg2)
x=[];y=[];typ=[];
select job
  case 'plot' then
    Ron=arg1.graphics.exprs(1);
    Goff=arg1.graphics.exprs(2);
    m=arg1.graphics.exprs(3);
    m=strcat(sci2exp(double(evstr(m))));
    standard_draw(arg1,%f,_CEMS_SignalVoltage_dp);
  case 'getinputs' then
    [x,y,typ]=_CEMS_SignalVoltage_ip(arg1);
  case 'getoutputs' then
    [x,y,typ]=_CEMS_SignalVoltage_op(arg1);
  case 'getorigin' then
    [x,y]=standard_origin(arg1);
  case 'set' then
    x=arg1;
    graphics=arg1.graphics;exprs=graphics.exprs;
    model=arg1.model;
    while %t do
      [ok,Ron,Goff,m,exprs]=..
        getvalue(['';'CEMI_IdealClosingSwitch';'';'Multiphase ideal closer';''],..
        [' Ron [Ohm] : Closed switch resistance',' Goff [S] : Opened switch conductance',' m [-] : number of phases (>1)'],..
        list('vec',-1,'vec',-1,'vec',1),exprs);
      if ~ok then break, end
      model.equations.parameters(2)=list(Ron,Goff,m)
      m=double(m);
      model.in=[1;m];
      model.out=[1];
      graphics.exprs=exprs;
      x.graphics=graphics;x.model=model;
      break
    end
  case 'define' then
    Ron=[0.00001,0.00001,0.00001];
    Goff=[0.00001,0.00001,0.00001];
    m=3;
    model=scicos_model();
    model.sim='Coselica';
    model.blocktype='c';
    model.dep_ut=[%t %f];
    model.in=[1;m];
    model.out=[1];
    m=int32(3);
    mo=modelica();
      mo.model='Coselica.Electrical.MultiPhase.Ideal.IdealClosingSwitch';
      mo.inputs=['plug_p','control'];
      mo.outputs=['plug_n'];
      mo.parameters=list(['Ron','Goff','m'],..
                         list(Ron,Goff,m),..
                         [0,0,0]);
    model.equations=mo;
    exprs=[strcat(sci2exp(Ron));strcat(sci2exp(Goff));strcat(sci2exp(m))];
    gr_i=[
          'if orient then';
          '  xx=orig(1);yy=orig(2);';
          '  ww=sz(1);hh=sz(2);';
          'else';
          '  xx=orig(1)+sz(1);yy=orig(2);';
          '  ww=-sz(1);hh=sz(2);';
          'end';
          'if orient then';
          '  xstringb(orig(1)+sz(1)*-0.25,orig(2)+sz(2)*0,""""+model.label+"""",sz(1)*1.5,sz(2)*0.3,""fill"");';
          'else';
          '  xstringb(orig(1)+sz(1)*(1--0.25-1.5),orig(2)+sz(2)*0,""""+model.label+"""",sz(1)*1.5,sz(2)*0.3,""fill"");';
          'end';
          'e=gce();';
          'e.visible=""on"";';
          'e.foreground=color(0,0,255);';
          'e.background=color(0,0,255);';
          'e.font_foreground=color(0,0,255);';
          'e.fill_mode=""off"";';
          'xpoly(xx+ww*[0.05;0.28],yy+hh*[0.5;0.5]);';
          'e=gce();';
          'e.visible=""on"";';
          'e.foreground=color(0,0,255);';
          'e.thickness=0.25;';
          'e.line_style=1;';
          'if orient then';
          '  xarc(orig(1)+sz(1)*0.28,orig(2)+sz(2)*0.52,sz(1)*0.04,sz(2)*0.04,0,23040);';
          'else';
          '  xarc(orig(1)+sz(1)*(1-0.28-0.04),orig(2)+sz(2)*0.52,sz(1)*0.04,sz(2)*0.04,11520,-23040);';
          'end';
          'e=gce();';
          'e.visible=""on"";';
          'e.foreground=color(0,0,255);';
          'e.background=color(0,0,0);';
          'e.fill_mode=""off"";';
          'e.thickness=0.25;';
          'e.line_style=1;';
          'xpoly(xx+ww*[0.315;0.7],yy+hh*[0.51;0.75]);';
          'e=gce();';
          'e.visible=""on"";';
          'e.foreground=color(0,0,255);';
          'e.thickness=0.25;';
          'e.line_style=1;';
          'xpoly(xx+ww*[0.5;0.5],yy+hh*[0.75;0.63]);';
          'e=gce();';
          'e.visible=""on"";';
          'e.foreground=color(0,0,255);';
          'e.thickness=0.25;';
          'e.line_style=1;';
          'xpoly(xx+ww*[0.7;0.95],yy+hh*[0.5;0.5]);';
          'e=gce();';
          'e.visible=""on"";';
          'e.foreground=color(0,0,255);';
          'e.thickness=0.25;';
          'e.line_style=1;';
          'if orient then';
          '  xstringb(orig(1)+sz(1)*-0.1,orig(2)+sz(2)*0.8,""m=""+string(m)+"""",sz(1)*0.4,sz(2)*0.2,""fill"");';
          'else';
          '  xstringb(orig(1)+sz(1)*(1--0.1-0.4),orig(2)+sz(2)*0.8,""m=""+string(m)+"""",sz(1)*0.4,sz(2)*0.2,""fill"");';
          'end';
          'e=gce();';
          'e.visible=""on"";';
          'e.foreground=color(0,0,0);';
          'e.background=color(0,0,0);';
          'e.font_foreground=color(0,0,0);';
          'e.fill_mode=""off"";'
         ];

    x=standard_define([2 2],model,exprs,list(gr_i,0));
    x.graphics.in_implicit=['I','E'];
    x.graphics.out_implicit=['I'];
  end
endfunction
