// Coselica Toolbox for Scicoslab
// Copyright (C) 2009-2012  Dirk Reusch, Kybernetik Dr. Reusch
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.

function [x,y,typ]=MEAB_Transformer(job,arg1,arg2)
x=[];y=[];typ=[];
select job
  case 'plot' then
    L1=arg1.graphics.exprs(1);
    L2=arg1.graphics.exprs(2);
    M=arg1.graphics.exprs(3);
    standard_draw(arg1,%f,_MEAI_TwoPort_dp);
  case 'getinputs' then
    [x,y,typ]=_MEAI_TwoPort_ip(arg1);
  case 'getoutputs' then
    [x,y,typ]=_MEAI_TwoPort_op(arg1);
  case 'getorigin' then
    [x,y]=standard_origin(arg1);
  case 'set' then
    x=arg1;
    graphics=arg1.graphics;exprs=graphics.exprs;
    model=arg1.model;
    while %t do
      [ok,L1,L2,M,exprs]=..
        getvalue(['';'MEAB_Transformer';'';'Transformer with two ports';''],..
        [' L1 [H] : Primary inductance',' L2 [H] : Secondary inductance',' M [H] : Coupling inductance'],..
        list('vec',1,'vec',1,'vec',1),exprs);
      if ~ok then break, end
      model.equations.parameters(2)=list(L1,L2,M)
      model.in=[1;1];
      model.out=[1;1];
      graphics.exprs=exprs;
      x.graphics=graphics;x.model=model;
      break
    end
  case 'define' then
    L1=1;
    L2=1;
    M=1;
    model=scicos_model();
    model.sim='Coselica';
    model.blocktype='c';
    model.dep_ut=[%t %f];
    model.in=[1;1];
    model.out=[1;1];
    mo=modelica();
      mo.model='Modelica.Electrical.Analog.Basic.Transformer';
      mo.inputs=['p1','n1'];
      mo.outputs=['p2','n2'];
      mo.parameters=list(['L1','L2','M'],..
                         list(L1,L2,M),..
                         [0,0,0]);
    model.equations=mo;
    exprs=[strcat(sci2exp(L1));strcat(sci2exp(L2));strcat(sci2exp(M))];
    gr_i=[
          'if orient then';
          '  xx=orig(1);yy=orig(2);';
          '  ww=sz(1);hh=sz(2);';
          'else';
          '  xx=orig(1)+sz(1);yy=orig(2);';
          '  ww=-sz(1);hh=sz(2);';
          'end';
          'if orient then';
          '  xstringb(orig(1)+sz(1)*0,orig(2)+sz(2)*0.8447,""""+model.label+"""",sz(1)*1,sz(2)*0.2898,""fill"");';
          'else';
          '  xstringb(orig(1)+sz(1)*(1-0-1),orig(2)+sz(2)*0.8447,""""+model.label+"""",sz(1)*1,sz(2)*0.2898,""fill"");';
          'end';
          'e=gce();';
          'e.visible=""on"";';
          'e.foreground=color(0,0,0);';
          'e.background=color(0,0,255);';
          'e.font_foreground=color(0,0,255);';
          'e.fill_mode=""off"";';
          'if orient then';
          '  xarc(orig(1)+sz(1)*0.275,orig(2)+sz(2)*0.375,sz(1)*0.125,sz(2)*0.125,-5760,11520);';
          'else';
          '  xarc(orig(1)+sz(1)*(1-0.275-0.125),orig(2)+sz(2)*0.375,sz(1)*0.125,sz(2)*0.125,17280,-11520);';
          'end';
          'e=gce();';
          'e.visible=""on"";';
          'e.foreground=color(0,0,255);';
          'e.background=color(0,0,0);';
          'e.fill_mode=""off"";';
          'e.thickness=0.25;';
          'e.line_style=1;';
          'if orient then';
          '  xarc(orig(1)+sz(1)*0.275,orig(2)+sz(2)*0.5,sz(1)*0.125,sz(2)*0.125,-5760,11520);';
          'else';
          '  xarc(orig(1)+sz(1)*(1-0.275-0.125),orig(2)+sz(2)*0.5,sz(1)*0.125,sz(2)*0.125,17280,-11520);';
          'end';
          'e=gce();';
          'e.visible=""on"";';
          'e.foreground=color(0,0,255);';
          'e.background=color(0,0,0);';
          'e.fill_mode=""off"";';
          'e.thickness=0.25;';
          'e.line_style=1;';
          'if orient then';
          '  xarc(orig(1)+sz(1)*0.275,orig(2)+sz(2)*0.625,sz(1)*0.125,sz(2)*0.125,-5760,11520);';
          'else';
          '  xarc(orig(1)+sz(1)*(1-0.275-0.125),orig(2)+sz(2)*0.625,sz(1)*0.125,sz(2)*0.125,17280,-11520);';
          'end';
          'e=gce();';
          'e.visible=""on"";';
          'e.foreground=color(0,0,255);';
          'e.background=color(0,0,0);';
          'e.fill_mode=""off"";';
          'e.thickness=0.25;';
          'e.line_style=1;';
          'if orient then';
          '  xarc(orig(1)+sz(1)*0.275,orig(2)+sz(2)*0.75,sz(1)*0.125,sz(2)*0.125,-5760,11520);';
          'else';
          '  xarc(orig(1)+sz(1)*(1-0.275-0.125),orig(2)+sz(2)*0.75,sz(1)*0.125,sz(2)*0.125,17280,-11520);';
          'end';
          'e=gce();';
          'e.visible=""on"";';
          'e.foreground=color(0,0,255);';
          'e.background=color(0,0,0);';
          'e.fill_mode=""off"";';
          'e.thickness=0.25;';
          'e.line_style=1;';
          'xpoly(xx+ww*[0.05;0.34],yy+hh*[0.75;0.75]);';
          'e=gce();';
          'e.visible=""on"";';
          'e.foreground=color(0,0,255);';
          'e.thickness=0.25;';
          'e.line_style=1;';
          'xpoly(xx+ww*[0.05;0.34],yy+hh*[0.25;0.25]);';
          'e=gce();';
          'e.visible=""on"";';
          'e.foreground=color(0,0,255);';
          'e.thickness=0.25;';
          'e.line_style=1;';
          'if orient then';
          '  xarc(orig(1)+sz(1)*0.6,orig(2)+sz(2)*0.375,sz(1)*0.125,sz(2)*0.125,5760,11520);';
          'else';
          '  xarc(orig(1)+sz(1)*(1-0.6-0.125),orig(2)+sz(2)*0.375,sz(1)*0.125,sz(2)*0.125,5760,-11520);';
          'end';
          'e=gce();';
          'e.visible=""on"";';
          'e.foreground=color(0,0,255);';
          'e.background=color(0,0,0);';
          'e.fill_mode=""off"";';
          'e.thickness=0.25;';
          'e.line_style=1;';
          'if orient then';
          '  xarc(orig(1)+sz(1)*0.6,orig(2)+sz(2)*0.5,sz(1)*0.125,sz(2)*0.125,5760,11520);';
          'else';
          '  xarc(orig(1)+sz(1)*(1-0.6-0.125),orig(2)+sz(2)*0.5,sz(1)*0.125,sz(2)*0.125,5760,-11520);';
          'end';
          'e=gce();';
          'e.visible=""on"";';
          'e.foreground=color(0,0,255);';
          'e.background=color(0,0,0);';
          'e.fill_mode=""off"";';
          'e.thickness=0.25;';
          'e.line_style=1;';
          'if orient then';
          '  xarc(orig(1)+sz(1)*0.6,orig(2)+sz(2)*0.625,sz(1)*0.125,sz(2)*0.125,5760,11520);';
          'else';
          '  xarc(orig(1)+sz(1)*(1-0.6-0.125),orig(2)+sz(2)*0.625,sz(1)*0.125,sz(2)*0.125,5760,-11520);';
          'end';
          'e=gce();';
          'e.visible=""on"";';
          'e.foreground=color(0,0,255);';
          'e.background=color(0,0,0);';
          'e.fill_mode=""off"";';
          'e.thickness=0.25;';
          'e.line_style=1;';
          'if orient then';
          '  xarc(orig(1)+sz(1)*0.6,orig(2)+sz(2)*0.75,sz(1)*0.125,sz(2)*0.125,5760,11520);';
          'else';
          '  xarc(orig(1)+sz(1)*(1-0.6-0.125),orig(2)+sz(2)*0.75,sz(1)*0.125,sz(2)*0.125,5760,-11520);';
          'end';
          'e=gce();';
          'e.visible=""on"";';
          'e.foreground=color(0,0,255);';
          'e.background=color(0,0,0);';
          'e.fill_mode=""off"";';
          'e.thickness=0.25;';
          'e.line_style=1;';
          'xpoly(xx+ww*[0.66;0.95],yy+hh*[0.75;0.75]);';
          'e=gce();';
          'e.visible=""on"";';
          'e.foreground=color(0,0,255);';
          'e.thickness=0.25;';
          'e.line_style=1;';
          'xpoly(xx+ww*[0.66;0.95],yy+hh*[0.25;0.25]);';
          'e=gce();';
          'e.visible=""on"";';
          'e.foreground=color(0,0,255);';
          'e.thickness=0.25;';
          'e.line_style=1;';
          'if orient then';
          '  xstringb(orig(1)+sz(1)*0.055,orig(2)+sz(2)*0.45,""L1"",sz(1)*0.145,sz(2)*0.14,""fill"");';
          'else';
          '  xstringb(orig(1)+sz(1)*(1-0.055-0.145),orig(2)+sz(2)*0.45,""L1"",sz(1)*0.145,sz(2)*0.14,""fill"");';
          'end';
          'e=gce();';
          'e.visible=""on"";';
          'e.foreground=color(0,0,0);';
          'e.background=color(0,0,255);';
          'e.font_foreground=color(0,0,255);';
          'e.fill_mode=""on"";';
          'if orient then';
          '  xstringb(orig(1)+sz(1)*0.82,orig(2)+sz(2)*0.45,""L2"",sz(1)*0.13,sz(2)*0.14,""fill"");';
          'else';
          '  xstringb(orig(1)+sz(1)*(1-0.82-0.13),orig(2)+sz(2)*0.45,""L2"",sz(1)*0.13,sz(2)*0.14,""fill"");';
          'end';
          'e=gce();';
          'e.visible=""on"";';
          'e.foreground=color(0,0,0);';
          'e.background=color(0,0,255);';
          'e.font_foreground=color(0,0,255);';
          'e.fill_mode=""on"";';
          'if orient then';
          '  xstringb(orig(1)+sz(1)*0.41,orig(2)+sz(2)*0.01,""M"",sz(1)*0.19,sz(2)*0.14,""fill"");';
          'else';
          '  xstringb(orig(1)+sz(1)*(1-0.41-0.19),orig(2)+sz(2)*0.01,""M"",sz(1)*0.19,sz(2)*0.14,""fill"");';
          'end';
          'e=gce();';
          'e.visible=""on"";';
          'e.foreground=color(0,0,0);';
          'e.background=color(0,0,255);';
          'e.font_foreground=color(0,0,255);';
          'e.fill_mode=""on"";'
         ];

    x=standard_define([2 2],model,exprs,list(gr_i,0));
    x.graphics.in_implicit=['I','I'];
    x.graphics.out_implicit=['I','I'];
  end
endfunction
