// Coselica Toolbox for Scicoslab
// Copyright (C) 2011  Dirk Reusch, Kybernetik Dr. Reusch
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.

function FindObsolete_()
    
    Cmenu = [];
    %pt   = [];
    Select= [];

    // retrieve gui names of obsolete blocks
    obs = read(cos_path() + "macros/Obsolete/names", -1, 1, '(a)');
    
    [ nobs, hobs ] = do_find_obsolete( scs_m, obs, %t );
    
    hilite_obj( hobs );
    
    if nobs <> 0 then
        message( [ "  Total number of obsolete blocks found : " + string(nobs);
                   " ";
                   "  For future compatibility it might be a good idea to";
                   " ";
                   "    a) replace highlighted non-super blocks  ";
                   "    b) examine highlighted super blocks, they contain at least one obsolete block  " ] );
    else
        message( [ "  Your diagram does not contain any obsolete blocks, however there might be  ";
                   "  antiquated blocks! Consider using ""Find Antiquated"" to find them!  " ]);
    end
    
    unhilite_obj( hobs );
    
endfunction

