// Coselica Toolbox for Scicoslab
// Copyright (C) 2012  Dirk Reusch, Kybernetik Dr. Reusch
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.

function FixAntiquated_()
    
    Cmenu = [];
    %pt   = [];
    Select= [];

    // retrieve gui names of (all) non-obsolete Coselica blocks to be checked
    chk = read(cos_path() + "macros/Blocks/Continuous/names", -1, 1, '(a)');
    chk = [chk; read(cos_path() + "macros/Blocks/Interfaces/names", -1, 1, '(a)') ];
    chk = [chk; read(cos_path() + "macros/Blocks/Math/names", -1, 1, '(a)') ];
    chk = [chk; read(cos_path() + "macros/Blocks/Nonlinear/names", -1, 1, '(a)') ];
    chk = [chk; read(cos_path() + "macros/Blocks/Routing/names", -1, 1, '(a)') ];
    chk = [chk; read(cos_path() + "macros/Blocks/Sources/names", -1, 1, '(a)') ];
    chk = [chk; read(cos_path() + "macros/Electrical/names", -1, 1, '(a)') ];
    chk = [chk; read(cos_path() + "macros/Mechanics/Translational/names", -1, 1, '(a)') ];
    chk = [chk; read(cos_path() + "macros/Mechanics/Rotational/names", -1, 1, '(a)') ];
    chk = [chk; read(cos_path() + "macros/Mechanics/Planar/names", -1, 1, '(a)') ];
    chk = [chk; read(cos_path() + "macros/Thermal/HeatTransfer/names", -1, 1, '(a)') ];

    [ nant, hant, scs_m ] = do_fix_antiquated( scs_m, chk, %t );
    
    hilite_obj( hant );
    
    if nant <> 0 then
        
        message( [ "  Total number of ANTIQUATED blocks fixed : " + string(nant); 
                   "  ";
                   "  Consider saving your diagram using a new name,";
                   "  because this automatic fix might be buggy!" ] );
        
        needcompile = 4;
        edited = %t;
        Cmenu = 'Replot';
        
    else
        
        message( [ "  Your diagram does not contain any antiquated blocks,  ";
                   "  thus your diagram has not changed at all!  " ]);
    end
    
    unhilite_obj( hant );
    
endfunction

