// Coselica Toolbox for Scicoslab
// Copyright (C) 2011  Dirk Reusch, Kybernetik Dr. Reusch
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.

function UpgradeObsolete_()
    
    Cmenu = [];
    %pt   = [];
    Select= [];

    // retrieve gui names of obsolete blocks
    obs = read(cos_path() + "macros/Obsolete/names", -1, 1, '(a)');
       
    [ nobs, hobs, scs_m ] = do_upgrade_obsolete( scs_m, obs, %t );
    
    hilite_obj( hobs );
    
    if nobs <> 0 then
      
        message( [ "  Total number of obsolete blocks upgraded : " + string(nobs);
                   "  ";
                   "  Your diagram still may contain obsolete blocks,  ";
                   "  which have to be upgraded manually!  ";
                   "  ";
                   "  Consider saving your diagram using a new name,  ";
                   "  because this automatic upgrade might be buggy!  " ] );
        
        needcompile = 4;
        edited = %t;
        Cmenu = 'Replot';
        
    else
        message( [ "  Your diagram does not contain any obsolete blocks,  ";
                   "  thus your diagram has not changed at all!  " ] );
    end
    
    unhilite_obj( hobs );
    
endfunction

