// Coselica Toolbox for Scicoslab
// Copyright (C) 2012  Dirk Reusch, Kybernetik Dr. Reusch
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.

function [ nobs, hobs ] = do_find_antiquated( scs_m, obs, hilite )
    
    nobs = 0;  // number of antiquated blocks found
    hobs = []; // object indices for highlighting
    
    objs = scs_m.objs;
    for i = 1:length(objs) do
        if typeof(objs(i)) == "Block" then
            o = objs(i);
            if find(o.gui == obs) <> [] then
                //disp(o.model.sim);
                if o.model.sim <> "Coselica" then
                  nobs = nobs + 1;
                  if hilite <> %f then
                    hobs($+1) = i; // highlight antiquated block
                  end
                end
              elseif o.gui == "SUPER_f" then
                [ nn, hh ] = do_find_antiquated( o.model.rpar, obs, %f );
                if nn > 0 then
                    nobs = nobs + nn;
                    if hilite <> %f then
                      hobs($+1) = i; // highlight super block containing antiquated blocks
                   end
                end
            end
        end
    end

endfunction

