// Coselica Toolbox for Scicoslab
// Copyright (C) 2011  Dirk Reusch, Kybernetik Dr. Reusch
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.

function [ nobs, hobs, scs_m_new ] = do_upgrade_obsolete( scs_m, obs, hilite )
    
    nobs = 0;  // number of obsolete blocks found
    hobs = []; // object indices for highlighting
    // upgrade table
    fromto = [  "MBC_Der",           "CBC_Der";
                "MBC_Derivative",    "CBC_Derivative";
                "MBC_FirstOrder",    "CBC_FirstOrder";
                "MBC_Integrator",    "CBC_Integrator";
                "MBC_LimIntegrator", "CBC_LimIntegrator";
                "MBC_LimPID",        "CBC_LimPID";
                "MBC_PI",            "CBC_PI";
                "MBC_PID",           "CBC_PID";
                "MBC_SecondOrder",   "CBC_SecondOrder";
                "MBM_Abs",           "CBM_Abs";
                "MBM_Acos",          "CBM_Acos";
                "MBM_Add",           "CBM_Add";
                "MBM_Asin",          "CBM_Asin";
                "MBM_Atan",          "CBM_Atan";
                "MBM_Cos",           "CBM_Cos";
                "MBM_Cosh",          "CBM_Cosh";
                "MBM_Division",      "CBM_Division";
                "MBM_Exp",           "CBM_Exp";
                "MBM_Feedback",      "CBM_Feedback";
                "MBM_Gain",          "CBM_Gain";
                "MBM_Log",           "CBM_Log";
                "MBM_Log10",         "CBM_Log10";
                "MBM_Max",           "CBM_Max";
                "MBM_Min",           "CBM_Min";
                "MBM_Product",       "CBM_Product";
                "MBM_Sign",          "CBM_Sign";
                "MBM_Sin",           "CBM_Sin";
                "MBM_Sinh",          "CBM_Sinh";
                "MBM_Sqrt",          "CBM_Sqrt";
                "MBM_Tan",              "CBM_Tan";
                "MBM_Tanh",             "CBM_Tanh"; 
                "MBN_DeadZone",         "CBN_DeadZone";
                "MBN_Limiter",          "CBN_Limiter";
                "MBS_Clock",            "CBS_Clock";
                "MBS_Constant",         "CBS_Constant";
                "MBS_Exponentials",     "CBS_Exponentials";
                "MBS_ExpSine",          "CBS_ExpSine";
                "MBS_Ramp",             "CBS_Ramp";
                "MBS_Sine",             "CBS_Sine";
                "MBS_Step",             "CBS_Step";
                "MBS_Pulse",            "CBS_Pulse";     // obsolete in 0.4.6
                "MBS_SawTooth",         "CBS_SawTooth";  // obsolete in 0.4.6
                "MEAB_Capacitor",       "CEAB_Capacitor";
                "MEAB_CCC",             "CEAB_CCC";
                "MEAB_CCV",             "CEAB_CCV";
                "MEAB_Ground",          "CEAB_Ground";
                "MEAB_Gyrator",         "CEAB_Gyrator";
                "MEAB_HeatingResistor",   "CEAB_HeatingResistor";
                "MEAB_Inductor",          "CEAB_Inductor";
                "MEAB_OpAmp",             "CEAB_OpAmp";
                "MEAB_Resistor",          "CEAB_Resistor";
                "MEAB_Transformer",       "CEAB_Transformer";
                "MEAB_VariableCapacitor", "CEAB_VariableCapacitor";
                "MEAB_VariableInductor",  "CEAB_VariableInductor";
                "MEAB_VariableResistor",  "CEAB_VariableResistor";
                "MEAB_VCC",               "CEAB_VCC";
                "MEAB_VCV",                "CEAB_VCV";
                "MEAI_IdealClosingSwitch", "CEAI_IdealClosingSwitch";
                "MEAI_IdealGyrator",       "CEAI_IdealGyrator";
                "MEAI_IdealOpeningSwitch", "CEAI_IdealOpeningSwitch";
                "MEAI_IdealTransformer",   "CEAI_IdealTransformer";
                "MEAI_Idle",               "CEAI_Idle";
                "MEAS_Diode",              "CEAS_Diode";
                "MEAS_NMOS",               "CEAS_NMOS";
                "MEAS_NPN",                "CEAS_NPN";
                "MEAS_PMOS",               "CEAS_PMOS";
                "MEAS_PNP",                "CEAS_PNP";
                "MEAS_CurrentSensor",      "CEAS_CurrentSensor";
                "MEAS_PotentialSensor",    "CEAS_PotentialSensor";
                "MEAS_VoltageSensor",      "CEAS_VoltageSensor";
                "MEAS_ConstantCurrent",    "CEAS_ConstantCurrent";
                "MEAS_ConstantVoltage",    "CEAS_ConstantVoltage";
                "MEAS_PulseCurrent",       "CEAS_PulseCurrent";
                "MEAS_PulseVoltage",       "CEAS_PulseVoltage";
                "MEAS_RampCurrent",        "CEAS_RampCurrent";
                "MEAS_RampVoltage",        "CEAS_RampVoltage";
                "MEAS_SawToothCurrent",    "CEAS_SawToothCurrent";
                "MEAS_SawToothVoltage",    "CEAS_SawToothVoltage";
                "MEAS_SignalCurrent",      "CEAS_SignalCurrent";
                "MEAS_SignalVoltage",      "CEAS_SignalVoltage";
                "MEAS_SineCurrent",        "CEAS_SineCurrent";
                "MEAS_SineVoltage",        "CEAS_SineVoltage";
                "MEAS_StepCurrent",        "CEAS_StepCurrent";
                "MEAS_StepVoltage",        "CEAS_StepVoltage";
                "MMRS_TorqueSensor",       "CMRS_TorqueSensor";
                "MMRS_RelAngleSensor",     "CMRS_RelAngleSensor";
                "MMRS_RelSpeedSensor",     "CMRS_RelSpeedSensor";
                "MMRS_RelAccSensor",       "CMRS_RelAccSensor";
                "MMRS_AngleSensor",        "CMRS_AngleSensor";
                "MMRS_SpeedSensor",        "CMRS_SpeedSensor";
                "MMRS_AccSensor",          "CMRS_AccSensor";
                "MTHC_FixedTemperature",    "CTHC_FixedTemperature";
                "MTHC_PrescribedTemperatu", "CTHC_PrescribedTemperatu";
                "MTHC_TemperatureSensor",   "CTHC_TemperatureSensor";
                "MTHC_ToKelvin",            "CTHC_ToKelvin";
                "MTHC_FromKelvin",          "CTHC_FromKelvin";
                "MMT_Fixed",              "CMTC_Fixed";..
                "MMT_Rod",                "CMTC_Rod";..
//                "MMT_Spring",             "CMTC_Spring";..
//                "MMT_Damper",             "CMTC_Damper";..
//                "MMT_SpringDamper",       "CMTC_SpringDamper";..
                "MMR_Fixed",                 "CMRC_Fixed";..
                "MMR_Spring",                "CMRC_Spring";..
                "MMR_Damper",                "CMRC_Damper";..
                "MMR_SpringDamper",          "CMRC_SpringDamper";..
                "MMR_IdealGear",             "CMRC_IdealGear";..
                "MMR_ElastoBacklash",        "CMRC_ElastoBacklash";..
                "MMR_IdealGearR2T",          "CMRC_IdealGearR2T";..
                "MMR_IdealPlanetary",        "CMRC_IdealPlanetary";..
                "MTH_ThermalConductor",      "CTHC_ThermalConductor";..
                "MTH_BodyRadiation",         "CTHC_BodyRadiation";..
                "MTH_Convection",            "CTHC_Convection";..
                "MTH_FixedTemperature",      "CTHS_FixedTemperature";..
                "MTH_FixedHeatFlow",         "CTHS_FixedHeatFlow";..
                "MTH_PrescribedTemperatur",  "CTHS_PrescribedTemperatu";..
                "MTH_PrescribedHeatFlow",    "CTHS_PrescribedHeatFlow";..
                "MTH_TemperatureSensor",     "CTHS_TemperatureSensor";..
                "MTH_HeatFlowSensor",        "CTHS_HeatFlowSensor";..
                "MTH_RelTemperatureSensor",  "CTHS_RelTemperatureSenso" ];
    
    from = fromto(:,1);
    to   = fromto(:,2);
  
    scs_m_new = scs_m;   

    objs = scs_m.objs;
    for i = 1:length(objs) do
        if typeof(objs(i)) == "Block" then
            o = objs(i);
            j = find(o.gui == from);
            if j <> [] then
                nobs = nobs + 1;
                if hilite <> %f then
                    hobs($+1) = i; // highlight obsolete block
                    // uprade block
                    execstr("o_new="+to(j)+"(""define"");");
                    scs_m_new.objs(i).gui = to(j);
                    gr_i = o_new.graphics.gr_i;
                    scs_m_new.objs(i).graphics.gr_i = gr_i;
                    scs_m_new.objs(i).model.sim = o_new.model.sim;
                    scs_m_new.objs(i).model.equations.model = o_new.model.equations.model;
                end
              elseif o.gui == "SUPER_f" then
                [ nn, hh ] = do_find_obsolete( o.model.rpar, obs, %f );
                if nn > 0 then
                    nobs = nobs + nn;
                    if hilite <> %f then
                      hobs($+1) = i; // highlight super block containing obsolete blocks
                   end
                end
            end
        end
    end

endfunction
  
